#include <stdio.h>
#include <string.h>
#include <mpi.h>

#define BUF_SIZE 80

int main(int argc, char* argv[])
{
	int		myid, size;
	char 	myname[MPI_MAX_PROCESSOR_NAME];
	int		mynamelen;
	char	buffer[BUF_SIZE];
	int		i;

	MPI_Init(&argc, &argv);

	MPI_Comm_rank (MPI_COMM_WORLD, &myid);
	MPI_Comm_size (MPI_COMM_WORLD, &size);

	MPI_Get_processor_name (myname, &mynamelen);
	if (myid == 0)
	{
		printf ("Master %d/%d@%s\n", myid, size, myname);
		for (i=1; i < size; i++)
		{
			MPI_Recv(buffer, BUF_SIZE, MPI_CHAR,
				     MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, 
					 MPI_STATUS_IGNORE);
			printf("%s", buffer);
		}
	}
	else
	{
		sprintf(buffer, "Proces %d/%d@%s.\n", myid, size, myname);
		MPI_Send(buffer, strlen(buffer)+1, MPI_CHAR,
			     0, myid, MPI_COMM_WORLD);
	}

	MPI_Finalize();

	return 0;
}
